//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <direct.h>
#include <Shlwapi.h>
#include <io.h>
#include <process.h>
#include <windows.h>

#include "testfindfileUnit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1* Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner) {}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject* Sender)
{
    FileOpenDialog1->CleanupInstance();

    if (FileOpenDialog1->Execute())
        Edit1->Text = FileOpenDialog1->FileName;
}
//---------------------------------------------------------------------------
/* __stdcall unsigned int  vc  unsigned int __stdcall */
__stdcall unsigned int TForm1::find_thread(void* arg)
{
    TForm1* me { reinterpret_cast<TForm1*>(arg) };

    if (me == nullptr) {
        return -1;
    }

    me->dir_count_ = 0;
    me->file_count_ = 0;
    me->stop_ = false;
    me->Button1->Enabled = false;
    me->Button2->Enabled = false;
    me->Button3->Enabled = false;
    me->do_find(me->Edit1->Text.c_str());
    me->Button1->Enabled = true;
    me->Button2->Enabled = true;
    me->Button3->Enabled = true;

    UnicodeString line;
    me->Memo1->Lines->Add(line.sprintf(L" %d ļ  %d ļС", me->file_count_, me->dir_count_));
    return 0U;
}
//---------------------------------------------------------------------------
int TForm1::do_find(const wchar_t* current_dir)
{
    if (current_dir == nullptr || current_dir[0] == L'\0')
        return -1;

    wchar_t work_dir_backup[_MAX_PATH];
    _wgetcwd(work_dir_backup, _MAX_PATH);
    _wchdir(current_dir);

    wchar_t current_path[_MAX_PATH];

    memset(current_path, 0, sizeof(current_path));
    wcsncpy_s(current_path, _MAX_PATH, current_dir, _MAX_PATH);
    wcsncat_s(current_path, _MAX_PATH, LR"raw(\)raw", 1);
    wcsncat_s(current_path, _MAX_PATH, L"*", 2);

    struct _wfinddatai64_t file_info;
    memset(&file_info, 0, sizeof(struct _wfinddatai64_t));

    intptr_t handle { _wfindfirsti64(current_path, &file_info) };
    if (handle == -1LL)
        return -1;

    do {
        if (file_info.name[0] == L'.' &&
            (file_info.name[1] == L'\0' || file_info.name[1] == L'.'))
            continue;
        memset(current_path, 0, sizeof(current_path));
        wcsncpy_s(current_path, _MAX_PATH, current_dir, _MAX_PATH);
        wcsncat_s(current_path, _MAX_PATH, L"\\", 1);
        wcsncat_s(current_path, _MAX_PATH, file_info.name, _MAX_PATH);

        if ((file_info.attrib & _A_SUBDIR) == _A_SUBDIR) {
            do_find(current_path);
            ++dir_count_;
        }
        else
        {
          ++file_count_;
        }
        Memo1->Lines->Add(current_path);
        memset(&file_info, 0, sizeof(struct _wfinddatai64_t));
    } while (!stop_ && _wfindnexti64(handle, &file_info) != -1);
    _findclose(handle);
    _wchdir(work_dir_backup);
    return file_count_ + dir_count_;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject* Sender)
{
    if (Edit1->Text.IsEmpty()) {
        return;
    }
    uintptr_t handle { _beginthreadex(
        nullptr, 0u, find_thread, reinterpret_cast<void*>(this), 0u, nullptr) };

    if (handle != 0) {
        CloseHandle(reinterpret_cast<HANDLE>(handle));
    }
}
//---------------------------------------------------------------------------
unsigned int __stdcall TForm1::find_thread_use_api(void* arg)
{
    TForm1* me { reinterpret_cast<TForm1*>(arg) };

    if (me == nullptr) {
        return -1;
    }

    me->dir_count_ = 0;
    me->file_count_ = 0;
    me->stop_ = false;
    me->Button1->Enabled = false;
    me->Button2->Enabled = false;
    me->Button3->Enabled = false;
    me->do_find_use_api(me->Edit1->Text.c_str());
    me->Button1->Enabled = true;
    me->Button2->Enabled = true;
    me->Button3->Enabled = true;

    UnicodeString line;
    me->Memo1->Lines->Add(line.sprintf(L" %d ļ  %d ļС", me->file_count_, me->dir_count_));
}
//---------------------------------------------------------------------------
int TForm1::do_find_use_api(const wchar_t* current_dir)
{
    if (current_dir == nullptr || current_dir[0] == L'\0')
        return -1;

    wchar_t work_dir_backup[_MAX_PATH];
    _wgetcwd(work_dir_backup, _MAX_PATH);
    _wchdir(current_dir);

    wchar_t current_path[_MAX_PATH];

    memset(current_path, 0, sizeof(current_path));
    wcsncpy_s(current_path, _MAX_PATH, current_dir, _MAX_PATH);
    wcsncat_s(current_path, _MAX_PATH, LR"raw(\)raw", 1);
    wcsncat_s(current_path, _MAX_PATH, L"*", 2);

    WIN32_FIND_DATAW find_data;
    memset(&find_data, 0, sizeof(WIN32_FIND_DATAW));

    HANDLE handle { FindFirstFileW(current_path, &find_data) };
    if (handle == INVALID_HANDLE_VALUE)
        return -1;

    do {
        if (find_data.cFileName[0] == L'.' &&
            (find_data.cFileName[1] == L'\0' || find_data.cFileName[1] == L'.'))
            continue;
        memset(current_path, 0, sizeof(current_path));
        wcsncpy_s(current_path, _MAX_PATH, current_dir, _MAX_PATH);
        wcsncat_s(current_path, _MAX_PATH, L"\\", 1);
        wcsncat_s(current_path, _MAX_PATH, find_data.cFileName, _MAX_PATH);
        if ((find_data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) ==
            FILE_ATTRIBUTE_DIRECTORY)
        {
            do_find_use_api(current_path);
            ++dir_count_;
        }
        else
        {
          ++file_count_;
        }

       Memo1->Lines->Add(current_path);
       memset(&find_data, 0, sizeof(WIN32_FIND_DATAW));
    } while (!stop_ && FindNextFileW(handle, &find_data));
    FindClose(handle);
    _wchdir(work_dir_backup);
    return file_count_ + dir_count_;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject* Sender)
{
    if (Edit1->Text.IsEmpty()) {
        return;
    }
    uintptr_t handle { _beginthreadex(
        nullptr, 0u, find_thread_use_api, reinterpret_cast<void*>(this), 0u, nullptr) };

    if (handle != 0) {
        CloseHandle(reinterpret_cast<HANDLE>(handle));
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   stop_ = true;
}
//---------------------------------------------------------------------------

